function out = model
%
% Heatlink.m
%
% Model exported on Aug 18 2010, 09:05 by COMSOL 4.0.0.982.

import com.comsol.model.*
import com.comsol.model.util.*

model = ModelUtil.create('Model');

model.modelPath('/home/aso/doc/Phys/notes/COMSOL_Tutorial');

model.param.set('g', '0[m/s^2]', 'Gravitational Acceleration');
model.param.set('ax', '1[m/s^2]', 'Horizontal acceleration in x');

model.modelNode.create('mod1');
model.modelNode.create('mod2');

model.geom.create('geom1', 3);
model.geom('geom1').model('mod1');
model.geom('geom1').feature.create('REV1', 'Composite');
model.geom('geom1').feature.create('BLK1', 'Block');
model.geom('geom1').feature.create('PT1', 'Point');
model.geom.create('geom2', 2);
model.geom('geom2').feature.create('C1', 'Circle');
model.geom('geom1').feature('REV1').set('filename', 'Heatlink_geom1_REV1.mphbin');
model.geom('geom1').feature('BLK1').set('pos', '0.35,-0.15,0.0');
model.geom('geom1').feature('BLK1').set('axis', {'0' '0' '1'});
model.geom('geom1').feature('BLK1').set('size', {'0.3' '0.3' '0.17'});
model.geom('geom1').feature('PT1').set('p', {'0.5'; '0'; '0.085'});
model.geom('geom1').setGeom('/home/aso/doc/Phys/notes/COMSOL_Tutorial/Heatlink_geom1.mphbin');
model.geom('geom2').feature('C1').set('pos', '0.0,0.0');
model.geom('geom2').feature('C1').set('r', '5.0E-4');
model.geom('geom2').setGeom('/home/aso/doc/Phys/notes/COMSOL_Tutorial/Heatlink_geom2.mphbin');

model.variable.create('var1');
model.variable('var1').set('uin', 'mod1.u-uexc', 'Displacement in the inertial frame');
model.variable('var1').set('uexc', '-ax/(2*pi*mod1.smsld.freq)^2', 'Excitation amplitude');
model.variable('var1').set('tfx', 'uin/uexc', 'Transfer function in x');
model.variable.create('cplvar1');
model.variable('cplvar1').model('mod1');
model.variable('cplvar1').set('intcpl_source_m1', 'smsld.rho');
model.variable('cplvar1').selection.geom('geom1', 3);
model.variable('cplvar1').selection.set([2]);
model.variable.create('cplvar2');
model.variable('cplvar2').set('m1', 'mod1.intop1(intcpl_source_m1)');

model.material.create('mat1');
model.material('mat1').model('mod1');
model.material('mat1').materialModel.create('Enu', 'Young''s modulus and Poisson''s ratio');
model.material('mat1').materialModel.create('Murnaghan', 'Murnaghan');
model.material('mat1').materialModel.create('Lame', ['Lam' native2unicode(hex2dec('00e9'), 'Cp1252') ' constants']);
model.material('mat1').materialModel.create('NeoHookean', 'Neo-Hookean');
model.material.create('mat2');
model.material('mat2').model('mod1');
model.material('mat2').materialModel.create('Enu', 'Young''s modulus and Poisson''s ratio');
model.material('mat2').selection.set([2]);

model.physics.create('smsld', 'SolidMechanics', 'geom1');
model.physics('smsld').identifier('smsld');
model.physics('smsld').feature('lemm1').feature.create('dmp1', 'Damping', 3);
model.physics('smsld').feature.create('lemm2', 'LinearElasticModel', 3);
model.physics('smsld').feature('lemm2').selection.set([1]);
model.physics('smsld').feature('lemm2').feature.create('dmp1', 'Damping', 3);
model.physics('smsld').feature.create('bl1', 'BodyLoad', 3);
model.physics('smsld').feature('bl1').selection.set([1 2]);
model.physics('smsld').feature('bl1').feature.create('ph1', 'Phase', 3);
model.physics('smsld').feature.create('fix1', 'Fixed', 2);
model.physics('smsld').feature('fix1').selection.set([1]);

model.mesh.create('mesh1', 'geom1');
model.mesh('mesh1').feature.create('obj', 'MeshObject');
model.mesh.create('mesh2', 'geom1');
model.mesh('mesh2').feature.create('ftet1', 'FreeTet');
model.mesh.create('mesh3', 'geom2');
model.mesh('mesh3').feature.create('obj', 'MeshObject');
model.mesh.create('mesh4', 'geom2');
model.mesh('mesh4').feature.create('ftri1', 'FreeTri');

model.frame.create('spatial_smsld', 'geom1');
model.frame('spatial_smsld').sshape.create('fixed1', 'moving_expr');
model.frame('spatial_smsld').sshape('fixed1').selection.geom('geom1');

model.cpl.create('intop1', 'Integration', 'geom1');
model.cpl('intop1').selection.set([2]);

model.material('mat1').name('Aluminum');
model.material('mat1').materialModel('def').set('heatcapacity', '900[J/(kg*K)]');
model.material('mat1').materialModel('def').set('thermalexpansioncoefficient', {'23e-6[1/K]' '0' '0' '0' '23e-6[1/K]' '0' '0' '0' '23e-6[1/K]'});
model.material('mat1').materialModel('def').set('relpermittivity', {'1' '0' '0' '0' '1' '0' '0' '0' '1'});
model.material('mat1').materialModel('def').set('thermalconductivity', {'160[W/(m*K)]' '0' '0' '0' '160[W/(m*K)]' '0' '0' '0' '160[W/(m*K)]'});
model.material('mat1').materialModel('def').set('relpermeability', {'1' '0' '0' '0' '1' '0' '0' '0' '1'});
model.material('mat1').materialModel('def').set('density', '2700[kg/m^3]');
model.material('mat1').materialModel('def').set('electricconductivity', {'3.774e7[S/m]' '0' '0' '0' '3.774e7[S/m]' '0' '0' '0' '3.774e7[S/m]'});
model.material('mat1').materialModel('Enu').set('youngsmodulus', '70e9[Pa]');
model.material('mat1').materialModel('Enu').set('poissonsratio', '0.33');
model.material('mat1').materialModel('Murnaghan').set('l', '-2.5e11[Pa]');
model.material('mat1').materialModel('Murnaghan').set('m', '-3.3e11[Pa]');
model.material('mat1').materialModel('Murnaghan').set('n', '-3.5e11[Pa]');
model.material('mat1').materialModel('Murnaghan').set('lambLame', '5.1e10[Pa]');
model.material('mat1').materialModel('Murnaghan').set('muLame', '2.6e10[Pa]');
model.material('mat1').materialModel('Lame').set('lambLame', '5.1e10[Pa]');
model.material('mat1').materialModel('Lame').set('muLame', '2.6e10[Pa]');
model.material('mat1').materialModel('NeoHookean').set('mu', '2.6e10[Pa]');
model.material('mat1').materialModel('NeoHookean').set('lambda', '5.1e10[Pa]');
model.material('mat2').name('Iron');
model.material('mat2').materialModel('def').set('heatcapacity', '440[J/(kg*K)]');
model.material('mat2').materialModel('def').set('thermalexpansioncoefficient', {'12.2e-6[1/K]' '0' '0' '0' '12.2e-6[1/K]' '0' '0' '0' '12.2e-6[1/K]'});
model.material('mat2').materialModel('def').set('relpermittivity', {'1' '0' '0' '0' '1' '0' '0' '0' '1'});
model.material('mat2').materialModel('def').set('thermalconductivity', {'76.2[W/(m*K)]' '0' '0' '0' '76.2[W/(m*K)]' '0' '0' '0' '76.2[W/(m*K)]'});
model.material('mat2').materialModel('def').set('relpermeability', {'4000' '0' '0' '0' '4000' '0' '0' '0' '4000'});
model.material('mat2').materialModel('def').set('density', '7870[kg/m^3]');
model.material('mat2').materialModel('def').set('electricconductivity', {'1.12e7[S/m]' '0' '0' '0' '1.12e7[S/m]' '0' '0' '0' '1.12e7[S/m]'});
model.material('mat2').materialModel('Enu').set('youngsmodulus', '200e9[Pa]');
model.material('mat2').materialModel('Enu').set('poissonsratio', '0.29');

model.physics('smsld').prop('ControlsSpatialFrame').set('ControlsSpatialFrame', '0');
model.physics('smsld').feature('lemm1').set('Evector_mat', 'userdef');
model.physics('smsld').feature('lemm1').set('Evector', {'2.0e11'; '2.0e11'; '2.0e11'});
model.physics('smsld').feature('lemm1').set('nuvector_mat', 'userdef');
model.physics('smsld').feature('lemm1').set('nuvector', {'0.33'; '0.33'; '0.33'});
model.physics('smsld').feature('lemm1').set('Gvector_mat', 'userdef');
model.physics('smsld').feature('lemm1').set('Gvector', {'7.52e10'; '7.52e10'; '7.52e10'});
model.physics('smsld').feature('lemm1').set('D_mat', 'userdef');
model.physics('smsld').feature('lemm1').set('D', {'2.0e11/((1+0.33)*(1-2*0.33))*(1-0.33)'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '0'; '0'; '0'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '2.0e11/((1+0.33)*(1-2*0.33))*(1-0.33)'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '0'; '0'; '0'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '2.0e11/((1+0.33)*(1-2*0.33))*(1-0.33)'; '0'; '0'; '0'; '0'; '0'; '0'; '2.0e11/((1+0.33)*2)'; '0'; '0'; '0'; '0'; '0'; '0'; '2.0e11/((1+0.33)*2)'; '0'; '0'; '0'; '0'; '0'; '0'; '2.0e11/((1+0.33)*2)'});
model.physics('smsld').feature('lemm1').set('AdvMatRes', '1');
model.physics('smsld').feature('lemm1').set('minput_frequency', 'freq');
model.physics('smsld').feature('lemm1').feature('dmp1').set('eta_s_mat', 'userdef');
model.physics('smsld').feature('lemm1').feature('dmp1').set('eta_s', '0.0001');
model.physics('smsld').feature('lemm1').feature('dmp1').set('DampingType', 'IsotropicLossFactor');
model.physics('smsld').feature('lemm1').feature('dmp1').set('minput_frequency', 'freq');
model.physics('smsld').feature('lemm2').set('E_mat', 'userdef');
model.physics('smsld').feature('lemm2').set('E', '68e9[Pa]');
model.physics('smsld').feature('lemm2').set('nu_mat', 'userdef');
model.physics('smsld').feature('lemm2').set('nu', '0.33');
model.physics('smsld').feature('lemm2').set('Evector_mat', 'userdef');
model.physics('smsld').feature('lemm2').set('Evector', {'2.0e11'; '2.0e11'; '2.0e11'});
model.physics('smsld').feature('lemm2').set('nuvector_mat', 'userdef');
model.physics('smsld').feature('lemm2').set('nuvector', {'0.33'; '0.33'; '0.33'});
model.physics('smsld').feature('lemm2').set('Gvector_mat', 'userdef');
model.physics('smsld').feature('lemm2').set('Gvector', {'7.52e10'; '7.52e10'; '7.52e10'});
model.physics('smsld').feature('lemm2').set('D_mat', 'userdef');
model.physics('smsld').feature('lemm2').set('D', {'2.0e11/((1+0.33)*(1-2*0.33))*(1-0.33)'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '0'; '0'; '0'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '2.0e11/((1+0.33)*(1-2*0.33))*(1-0.33)'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '0'; '0'; '0'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '2.0e11/((1+0.33)*(1-2*0.33))*0.33'; '2.0e11/((1+0.33)*(1-2*0.33))*(1-0.33)'; '0'; '0'; '0'; '0'; '0'; '0'; '2.0e11/((1+0.33)*2)'; '0'; '0'; '0'; '0'; '0'; '0'; '2.0e11/((1+0.33)*2)'; '0'; '0'; '0'; '0'; '0'; '0'; '2.0e11/((1+0.33)*2)'});
model.physics('smsld').feature('lemm2').set('rho_mat', 'userdef');
model.physics('smsld').feature('lemm2').set('rho', '2700[kg/m^3]');
model.physics('smsld').feature('lemm2').set('AdvMatRes', '1');
model.physics('smsld').feature('lemm2').set('minput_frequency', 'freq');
model.physics('smsld').feature('lemm2').feature('dmp1').set('eta_s_mat', 'userdef');
model.physics('smsld').feature('lemm2').feature('dmp1').set('eta_s', '0.0001');
model.physics('smsld').feature('lemm2').feature('dmp1').set('DampingType', 'IsotropicLossFactor');
model.physics('smsld').feature('lemm2').feature('dmp1').set('minput_frequency', 'freq');
model.physics('smsld').feature('bl1').set('FperVol', {'smsld.rho*ax'; '0'; '-smsld.rho*g'});
model.physics('smsld').feature('bl1').feature('ph1').set('FPh', {'(0)*pi/180'; '(0)*pi/180'; '(0)*pi/180'});

model.mesh('mesh1').feature('obj').set('filename', 'Heatlink_mesh1_obj.mphbin');
model.mesh('mesh1').run;
model.mesh('mesh2').feature('size').set('hauto', 3);
model.mesh('mesh2').run;
model.mesh('mesh3').feature('obj').set('filename', 'Heatlink_mesh3_obj.mphbin');
model.mesh('mesh3').run;
model.mesh('mesh4').run;

model.cpl('intop1').set('frame', 'material');

model.coordSystem('sys1').set('mastersystem', 'manual');

model.study.create('std1');
model.study('std1').feature.create('freq1', 'Frequency');

model.sol.create('sol1');
model.sol('sol1').attach('std1');
model.sol.create('sol2');
model.sol.create('sol3');
model.sol('sol1').feature.create('st1', 'StudyStep');
model.sol('sol1').feature.create('v1', 'Variables');
model.sol('sol1').feature.create('s1', 'Stationary');
model.sol('sol1').feature('s1').feature.create('p1', 'Parametric');
model.sol('sol1').feature('s1').feature.create('d1', 'Direct');

model.result.create('pg1', 3);
model.result('pg1').feature.create('vol1', 'Volume');
model.result('pg1').feature('vol1').feature.create('def1', 'Deform');
model.result.create('pg2', 1);
model.result('pg2').feature.create('glob1', 'Global');

model.study('std1').feature('freq1').set('mesh', {'geom1' 'mesh1' 'geom2' 'mesh3'});
model.study('std1').feature('freq1').set('plist', '10^{range(-3,4/9,1)}');

model.sol('sol1').feature('st1').name('Compile Equations: Frequency Domain 1');
model.sol('sol1').feature('st1').set('studystep', 'freq1');
model.sol('sol1').feature('v1').set('initmethod', 'sol');
model.sol('sol1').feature('v1').set('initsol', 'sol2');
model.sol('sol1').feature('v1').set('notsolmethod', 'sol');
model.sol('sol1').feature('v1').set('notsol', 'sol2');
model.sol('sol1').feature('s1').set('stol', '1.0E-6');
model.sol('sol1').feature('s1').set('nonlin', 'off');
model.sol('sol1').feature('s1').set('linpsol', 'sol2');
model.sol('sol1').feature('s1').feature('p1').set('pname', {'freq'});
model.sol('sol1').feature('s1').feature('p1').set('plist', '10^{range(-3,4/9,1)}');
model.sol('sol1').feature('s1').feature('p1').set('porder', 'linear');
model.sol('sol1').feature('s1').feature('d1').set('linsolver', 'spooles');
model.sol('sol1').feature('s1').feature('d1').set('errorchk', 'off');
model.sol('sol2').name('COMSOL 3.5a Stored Solution');
model.sol('sol2').runAll;
model.sol('sol3').name('COMSOL 3.5a Solution');
model.sol('sol3').runAll;

model.result('pg1').set('data', 'dset5');
model.result('pg1').set('solnum', '6');
model.result('pg1').feature('vol1').set('expr', 'smsld.mises');
model.result('pg1').feature('vol1').set('unit', 'Pa');
model.result('pg1').feature('vol1').set('descr', 'smsld.mises');
model.result('pg2').set('data', 'dset5');
model.result('pg2').set('solnum', {'1' '2' '3' '4' '5' '6' '7' '8' '9' '10'});
model.result('pg2').feature('glob1').set('expr', {'m1'});
model.result('pg2').feature('glob1').set('unit', {'m^3'});
model.result('pg2').feature('glob1').set('descr', {''});
model.result('pg2').feature('glob1').set('legend', false);

model.name('Heatlink.mph');

out = model;
